{$APPTYPE GUI}
{$R yuandian.res}
program yuandian;
uses windows,display;

var cheat:boolean=false;
var gsit:shortint=0;

const c:array[0..4]of longword=($010000,$010000,$000101,$00101,$000001);

var w:longword;
var h:longword;
var ptemp,ptext:pbitmap;
var ctemp,ctext:byte;

const framerate=60;
var frame:longword=0;
var pause:longword=0;
var pauseframe:longword=0;

const bdlmax=25;
const bdwmax=$100;
const bdhmax=$100;
const bdsz=20;
const stpmax=$10000;
const stpstp=$A0;
const stppmax=stpmax div stpstp;
const textmax=$10;

var pbd:array[0..5]of pbitmap;
var bd:array[0..bdlmax,0..bdwmax-1,0..bdhmax-1]of shortint;
var bdlv,bdln:shortint;
var bdw,bdh:shortint;
var bdix,bdiy,bdox,bdoy,bdex,bdey:array[0..bdlmax]of longint;

var stpx,stpy:array[0..bdlmax,0..stpmax]of real;
var stpn:array[0..bdlmax]of longword;
var stpm:array[0..bdlmax]of longword;
var stpp:array[0..bdlmax,0..stppmax]of boolean;

var stext:array[0..bdlmax,1..2,1..4]of string;
var stexti:longword;
var curtext:array[1..4]of string;
var curtextc:longword;
var curtextx,curtexty:longword;

var px,py,vx,vy:real;
var ax:real=0.1;
var ay:real=0.15;
const pw=16;
const ph=36;
const maxvx=4;
const maxvy=5;

var kl:shortint=0;
var kr:shortint=0;
var ku:shortint=0;

procedure drawbd(bdx,bdy,bdk:longint);
begin
drawbmp(pbd[bdk],bdx*bdsz,bdy*bdsz);
end;

procedure drawbdall();
var bdx,bdy:shortint;
begin
for bdx:=0 to bdw-1 do
  for bdy:=0 to bdh-1 do
    drawbd(bdx,bdy,bd[bdlv,bdx,bdy]);
end;

function bd2x(x:longint):longint;
begin bd2x:=round(x*bdsz+bdsz/2);end;
function bd2y(y:longint):longint;
begin bd2y:=round(y*bdsz+bdsz-ph/2);end;

procedure drawrect(stpc:longword;colorc:longword);
begin
bar(round(stpx[bdlv,stpc]-pw/2),round(stpy[bdlv,stpc]-ph/2),pw,ph,($80-colorc)*c[3-gsit]);
end;

function GetStrWidth(s:string):longword;
begin
GetStrWidth:=length(s)*_fw;
end;

procedure drawrectall();
var stpc:longint;
var stppi:longint=0;
var colorc:longword=$80;
var phi,pho:longword;
begin
stpc:=stpn[bdlv]-stpstp;
while stpc>0 do
  begin
  colorc:=colorc div 2;
  stppi:=stppi+1;
  if (gsit=1) or ((gsit=2) and not stpp[bdlv,stppi]) then
    drawrect(stpc,colorc);
  stpc:=stpc-stpstp;
  end;
colorc:=colorc div 2;
phi:=round(-stpc/stpstp*ph);
pho:=round((stpn[bdlv]+1)/stpm[bdlv]*ph);
if pho>ph then pho:=ph;
if gsit>=1 then
  bar(round(bd2x(bdix[bdlv])-pw/2),round(bd2y(bdiy[bdlv])-ph/2)+phi,pw,ph-phi,($7F-colorc)*c[3-gsit]);
bar(round(bd2x(bdox[bdlv])-pw/2),round(bd2y(bdoy[bdlv])-ph/2),pw,pho,$BF*c[gsit]);
if gsit=0 then
  bar(round(bd2x(bdex[bdlv])-pw/2),round(bd2y(bdey[bdlv])-ph/2),pw,ph,$FF*c[4]);
drawrect(stpn[bdlv],$80);
end;

procedure drawpause();
begin
if (pause=1) and (ctemp=0) then
  begin
  if gsit<2 then curtext:=stext[bdlv,1];
  if gsit=2 then curtext:=stext[bdlv,2];
  if gsit<2 then curtextc:=c[1]*$BF;
  if gsit=2 then curtextc:=c[2]*$7F;
  end;
if pause=1 then ctemp:=ctemp+4;
if pause=3 then ctemp:=ctemp-4;
if ctemp=$100-4 then pause:=2;
if ctemp=0 then pause:=0;
ctext:=$FF-ctemp;
drawbmp(_pmain,ptemp);
clear();
drawbmp(ptemp,ctemp shl 24);
clear(ptext);
for stexti:=1 to 4 do
  begin
  if (stexti=1) or (stexti=2) then setfontname('');
  if (stexti=3) or (stexti=4) then setfontname('Consolas');
  setfontsize(14,28);
  setfont(ptext);
  curtextx:=max(0,(w-GetStrWidth(curtext[stexti])) div 2);
  curtexty:=max(0,(h-GetStringHeight(curtext[stexti])) div 2+stexti*30-100);
  drawtextxy(ptext,curtext[stexti],curtextx,curtexty,curtextc);
  end;
if iswin then drawbmp(ptext,ctext shl 24);
end;

procedure drawall();
begin
clear();
drawbdall();
drawrectall();
drawpause();
freshwin();
end;

function hitstp(x1,x2,y1,y2:real):boolean;
begin
hitstp:=false;
hitstp:=hitstp
or ((abs(x1-x2)<pw)
and (abs(y1-y2)<ph));
end;

function hitstp(stpn,stpc:longword):boolean;
begin
hitstp:=hitstp(stpx[bdlv,stpn],stpx[bdlv,stpc],stpy[bdlv,stpn],stpy[bdlv,stpc]);
end;

function nostp():boolean;
var stppi:longword;
var stpc:longint;
begin
nostp:=true;
stpc:=stpn[bdlv]-stpstp;
while stpc>0 do
  begin
  stppi:=stppi+1;
  if not stpp[bdlv,stppi] then nostp:=false;
  stpc:=stpc-stpstp;
  end;
end;

function endestp(stpn:longword):boolean;
begin
endestp:=hitstp(stpx[bdlv,stpn],bd2x(bdex[bdlv]),stpy[bdlv,stpn],bd2y(bdey[bdlv]));
endestp:=endestp and (gsit=0);
end;

function endistp(stpn:longword):boolean;
begin
endistp:=hitstp(stpx[bdlv,stpn],bd2x(bdix[bdlv]),stpy[bdlv,stpn],bd2y(bdiy[bdlv]));
endistp:=endistp and nostp();
end;

function endostp(stpn:longword):boolean;
begin
endostp:=hitstp(stpx[bdlv,stpn],bd2x(bdox[bdlv]),stpy[bdlv,stpn],bd2y(bdoy[bdlv]));
endostp:=endostp and (stpn>=stpm[bdlv]);
end;

procedure erasestp();
var stpc:longint;
var stppi:longint=0;
var stppii:longint;
begin
stpc:=stpn[bdlv]-stpstp;
while stpc>0 do
  begin
  stppi:=stppi+1;
  if hitstp(stpn[bdlv],stpc) then
    begin
    if gsit=1 then
      begin
      stpn[bdlv]:=stpc;
      px:=stpx[bdlv,stpn[bdlv]];
      py:=stpy[bdlv,stpn[bdlv]];
      vx:=0;
      vy:=0;
      end;
    if gsit=2 then
      begin
      stpp[bdlv,stppi]:=true;
      end;
    end;
  if not stpp[bdlv,stppi] and endostp(stpc) then
    if gsit=2 then
      begin
      px:=bd2x(bdox[bdlv]);
      py:=bd2y(bdoy[bdlv]);
      vx:=0;
      vy:=0;
      for stppii:=stppi+1 to stppmax do stpp[bdlv,stppii]:=false;
      end;
  stpc:=stpc-stpstp;
  end;
end;

function istop():boolean;
begin
istop:=(bd[bdlv,trunc((px+1-pw/2)/bdsz),trunc((py-ph/2)/bdsz)]=1)
    or (bd[bdlv,trunc((px-1+pw/2)/bdsz),trunc((py-ph/2)/bdsz)]=1);
end;

function isbot():boolean;
begin
isbot:=(bd[bdlv,trunc((px+1-pw/2)/bdsz),trunc((py+ph/2)/bdsz)]=1)
    or (bd[bdlv,trunc((px-1+pw/2)/bdsz),trunc((py+ph/2)/bdsz)]=1);
end;

function isleft():boolean;
begin
isleft:=(bd[bdlv,trunc((px-pw/2-1)/bdsz),trunc((py+1-ph/2)/bdsz)]=1)
     or (bd[bdlv,trunc((px-pw/2-1)/bdsz),trunc((py)/bdsz)]=1)
     or (bd[bdlv,trunc((px-pw/2-1)/bdsz),trunc((py-1+ph/2)/bdsz)]=1);
end;

function isright():boolean;
begin
isright:=(bd[bdlv,trunc((px+pw/2)/bdsz),trunc((py+1-ph/2)/bdsz)]=1)
      or (bd[bdlv,trunc((px+pw/2)/bdsz),trunc((py)/bdsz)]=1)
      or (bd[bdlv,trunc((px+pw/2)/bdsz),trunc((py-1+ph/2)/bdsz)]=1);
end;

procedure makestp();
begin
if vx=0 then
  begin
  vx:=vx+(kr-kl)*ax;
//  if isbot() then
    begin
    if vx>0 then vx:=+maxvx div 3*2;
    if vx<0 then vx:=-maxvx div 3*2;
    end
  end
else if vx>0 then
  begin
  if (kl=kr) then vx:=round(vx/2);
  if (kr>0) and (kl=0) then vx:=vx+ax else vx:=vx-ax;
  if vx<0 then vx:=0;
  end
else if vx<0 then
  begin
  if (kl=kr) then vx:=round(vx/2);
  if (kl>0) and (kr=0) then vx:=vx-ax else vx:=vx+ax;
  if vx>0 then vx:=0;
  end;
if vx<-maxvx then vx:=-maxvx;
if vx>+maxvx then vx:=+maxvx;
if ku=1 then
  begin
  if isbot() or isleft() or isright() then vy:=-maxvy;
  if not(isbot()) then
    begin
    if isleft() then vx:=+maxvx;
    if isright() then vx:=-maxvx;
    end
  end;
if ku>=1 then ku:=2;
vy:=vy+ay;
py:=py+vy;
if py<bdsz then py:=bdsz;
if py>h-bdsz then py:=h-bdsz;
if (vy>0) and isbot() then
  begin
  vy:=0;
  py:=trunc((py+ph/2)/bdsz)*bdsz-ph/2;
  end;
if (vy<0) and istop() then
  begin
  vy:=0;
  py:=trunc((py-ph/2)/bdsz)*bdsz+ph/2+bdsz;
  end;
px:=px+vx;
if px<bdsz then px:=bdsz;
if px>w-bdsz then px:=w-bdsz;
if (vx>0) and isright() then
  begin
  vx:=0;
  px:=trunc((px+pw/2)/bdsz)*bdsz-pw/2;
  end;
if (vx<0) and isleft() then
  begin
  vx:=0;
  px:=trunc((px-pw/2-1)/bdsz)*bdsz+pw/2+bdsz;
  end;
if (px<>stpx[bdlv,stpn[bdlv]]) or (py<>stpy[bdlv,stpn[bdlv]]) then
  begin
  stpn[bdlv]:=stpn[bdlv]+1;
  stpx[bdlv,stpn[bdlv]]:=px;
  stpy[bdlv,stpn[bdlv]]:=py;
  end;
end;

function iskey(key:shortint):boolean;
begin iskey:=_ms.wParam=key;end;

procedure initbd();
var bdx,bdy:shortint;
var f:textfile;
var c:char;
begin
if isfile('ǧ') then cheat:=true;
assign(f,'yuandian.dat');
reset(f);
readln(f,bdln);
readln(f,bdw,bdh);
for bdlv:=0 to bdln do
  for stexti:=1 to 4 do
    readln(f,stext[bdlv,1,stexti]);
for bdlv:=bdlv downto 1 do
  for stexti:=1 to 4 do
    readln(f,stext[bdlv,2,stexti]);
for bdlv:=0 to bdln do
  begin
  readln(f,stpm[bdlv]);
  if cheat then stpm[bdlv]:=1;
  stpn[bdlv]:=0;
  for bdy:=0 to bdh-1 do
    begin
    for bdx:=0 to bdw-1 do
      begin
      read(f,c);
      bd[bdlv,bdx,bdy]:=0;
      if c='x' then bd[bdlv,bdx,bdy]:=1;
      if c='i' then begin bdix[bdlv]:=bdx;bdiy[bdlv]:=bdy;end;
      if c='o' then begin bdox[bdlv]:=bdx;bdoy[bdlv]:=bdy;end;
      if c='e' then begin bdex[bdlv]:=bdx;bdey[bdlv]:=bdy;end;
      end;
    readln(f);
    end;
  for bdx:=0 to bdw-1 do bd[bdlv,bdx,0]:=1;
  for bdx:=0 to bdw-1 do bd[bdlv,bdx,bdh-1]:=1;
  for bdy:=0 to bdh-1 do bd[bdlv,0,bdy]:=1;
  for bdy:=0 to bdh-1 do bd[bdlv,bdw-1,bdy]:=1;
  end;
close(f);
bdlv:=0;
gsit:=0;
end;

procedure initlv();
var stppi:longword;
begin
if gsit<2 then
  begin
  px:=bd2x(bdix[bdlv]);
  py:=bd2y(bdiy[bdlv]);
  stpn[bdlv]:=0;
  end;
if gsit=2 then
  begin
  px:=bd2x(bdox[bdlv]);
  py:=bd2y(bdoy[bdlv]);
  end;
vx:=0;
vy:=0;
for stppi:=0 to stppmax do stpp[bdlv,stppi]:=false;
stpx[bdlv,0]:=px;
stpy[bdlv,0]:=py;
end;

procedure initwin();
var bdp:shortint;
begin
w:=bdw*bdsz;
h:=bdh*bdsz;
createwin(w,h,black,white);
_wc.HIcon:=LoadIcon(MainInstance,'MAINICON');
sendmessage(_hw,WM_SETICON,ICON_BIG,longint(_wc.HIcon));
settitle('ԭ');
ptemp:=CreateBMP();
ptext:=CreateBMP();
for bdp:=0 to 5 do
  pbd[bdp]:=createbmp(bdsz,bdsz,white);
bar(pbd[1],0,0,bdsz,bdsz,gray);
end;

begin
initbd();
initwin();
initlv();
repeat
if gettime>frame/framerate*1000 then
  begin
  while gettime>frame/framerate*1000 do
    begin
    frame:=frame+1;
    if pause=0 then
      begin
      makestp();
      if stpn[bdlv]>=stpmax then begin initlv();stpn[bdlv]:=0;end;
      erasestp();
      if endostp(stpn[bdlv]) then
        begin
        if (bdlv=0) and (gsit=0) then pause:=1
        else if (bdlv<bdln) and (gsit=1) then pause:=1
        else if (bdlv=bdln) and (gsit=1) then pause:=1
        end;
      if endistp(stpn[bdlv]) then
        begin
        if (bdlv=1) and (gsit=2) then pause:=1
        else if (bdlv>1) and (gsit=2) then pause:=1
        end;
      end;
    if endestp(stpn[bdlv]) then
      closewin();
    end;
  if (stpn[bdlv]>0) or (pause=3) or (bdlv=0) then drawall();
  delay(1);
  end;
if isnextmsg then
  begin
  if ismsg(WM_KEYDOWN) then
    begin
    if iskey(K_LEFT) then kl:=1;
    if iskey(K_RIGHT) then kr:=1;
    if iskey(K_UP) then ku:=ku+1;
    if iskey(K_ESC) then closewin();
    if pause=2 then
      begin
      if endostp(stpn[bdlv]) then
        begin
        if (bdlv=0) and (gsit=0) then begin gsit:=1;bdlv:=1;initlv();pause:=3;end
        else if (bdlv<bdln) and (gsit=1) then begin bdlv:=bdlv+1;initlv();pause:=3;end
        else if (bdlv=bdln) and (gsit=1) then begin gsit:=2;pause:=3;end;
        end;
      if endistp(stpn[bdlv]) then
        begin
        if (bdlv=1) and (gsit=2) then begin gsit:=0;bdlv:=0;initlv();pause:=3;end
        else if (bdlv>1) and (gsit=2) then begin bdlv:=bdlv-1;initlv();pause:=3;end;
        end;
      end;
    end;
  if ismsg(WM_KEYUP) then
    begin
    if iskey(K_LEFT) then kl:=0;
    if iskey(K_RIGHT) then kr:=0;
    if iskey(K_UP) then ku:=0;
    end;
  end;
until not(iswin());
end.
